// XMLBuilder.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "XMLBuilderInternal.h"

#define _AD0A6BF9_5430_4ce7_91C4_6F344E02596D
#include "XMLBuilder.h"
#include "xml.h"
#include "XMLClass.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//              any functions exported from this DLL which call into
//              MFC must have the AFX_MANAGE_STATE macro added at the
//              very beginning of the function.
//
//              For example:
//
//              extern "C" BOOL PASCAL EXPORT ExportedFunction()
//              {
//                      AFX_MANAGE_STATE(AfxGetStaticModuleState());
//                      // normal function body here
//              }
//
//              It is very important that this macro appear in each
//              function, prior to any calls into MFC.  This means that
//              it must appear as the first statement within the 
//              function, even before any object variable declarations
//              as their constructors may generate calls into the MFC
//              DLL.
//
//              Please see MFC Technical Notes 33 and 58 for additional
//              details.
//


// CXMLBuilderApp

BEGIN_MESSAGE_MAP(CXMLBuilderApp, CWinApp)
END_MESSAGE_MAP()


// CXMLBuilderApp construction

CXMLBuilderApp::CXMLBuilderApp()
{
        // TODO: add construction code here,
        // Place all significant initialization in InitInstance
}


// The one and only CXMLBuilderApp object

CXMLBuilderApp theApp;


// CXMLBuilderApp initialization

BOOL CXMLBuilderApp::InitInstance()
{
        CWinApp::InitInstance();

        return TRUE;
}

/****************************************************************************
*                                   StringToXML
* Inputs:
*       const CString & source
* Result: XMLNode *
*       Parsed tree
* Effect: 
*       Parses
****************************************************************************/

__declspec(dllexport) 
XMLNode * StringToXML(const CString & source)
    {
     AFX_MANAGE_STATE(AfxGetStaticModuleState());
     XML parser;
     return parser.Build(source);
    } // StringToXML

/****************************************************************************
*                                 XMLToString
* Inputs:
*       const XMLNode * node: XML tree
*       BOOL CRLF: TRUE to use CRLF, FALSE to use LF
* Result: CString
*       A printable string
****************************************************************************/

__declspec(dllexport)
CString XMLToString(const XMLNode * node, BOOL CRLF)
    {
     AFX_MANAGE_STATE(AfxGetStaticModuleState());
     CString result;
     node->UnParse(result, CRLF, 0);
     return result;
    } // XMLToString

/****************************************************************************
*                                   XMLCopy
* Inputs:
*       XMLNode * node: Node type to copy
* Result: XMLNode *
*       A copy of the node and all its subnodes
* Effect: 
*       
****************************************************************************/

__declspec(dllexport)
XMLNode * XMLCopy(XMLNode * node)
    {
     return XMLNode::Copy(node);
    } // XMLCopy
